diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/model/sixlowpan-net-device.h ns-3.41/src/sixlowpan/model/sixlowpan-net-device.h
--- ns-3.40/src/sixlowpan/model/sixlowpan-net-device.h	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/model/sixlowpan-net-device.h	2024-02-09 14:44:08.461794100 -0800
@@ -86,6 +86,11 @@
     };
 
     /**
+     * \brief The protocol number for 6LoWPAN (0xA0ED) - see \RFC{7973}.
+     */
+    static constexpr uint16_t PROT_NUMBER{0xA0ED};
+
+    /**
      * \brief Get the type ID.
      * \return The object TypeId.
      */
@@ -626,14 +631,6 @@
     Ptr<NetDevice> m_netDevice; //!< Smart pointer to the underlying NetDevice.
     uint32_t m_ifIndex;         //!< Interface index.
 
-    /**
-     * \brief Force the EtherType number.
-     * Also implying that the underlying NetDevice is using 48-bit Addresses, e.g., Ethernet, Wi-Fi,
-     * etc.
-     */
-    bool m_forceEtherType;
-
-    uint16_t m_etherType;   //!< EtherType number (used only if m_forceEtherType is true).
     bool m_omitUdpChecksum; //!< Omit UDP checksum in NC1 encoding.
 
     uint32_t m_compressionThreshold; //!< Minimum L2 payload size.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/test/sixlowpan-fragmentation-test.cc ns-3.41/src/sixlowpan/test/sixlowpan-fragmentation-test.cc
--- ns-3.40/src/sixlowpan/test/sixlowpan-fragmentation-test.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/test/sixlowpan-fragmentation-test.cc	2024-02-09 14:44:08.461794100 -0800
@@ -289,7 +289,6 @@
         serverNode->AddDevice(serverDev);
 
         Ptr<SixLowPanNetDevice> serverSix = CreateObject<SixLowPanNetDevice>();
-        serverSix->SetAttribute("ForceEtherType", BooleanValue(true));
         serverNode->AddDevice(serverSix);
         serverSix->SetNetDevice(serverDev);
 
@@ -320,7 +319,6 @@
         clientNode->AddDevice(clientDev);
 
         Ptr<SixLowPanNetDevice> clientSix = CreateObject<SixLowPanNetDevice>();
-        clientSix->SetAttribute("ForceEtherType", BooleanValue(true));
         clientNode->AddDevice(clientSix);
         clientSix->SetNetDevice(clientDev);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/test/sixlowpan-hc1-test.cc ns-3.41/src/sixlowpan/test/sixlowpan-hc1-test.cc
--- ns-3.40/src/sixlowpan/test/sixlowpan-hc1-test.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/test/sixlowpan-hc1-test.cc	2024-02-09 14:44:08.461794100 -0800
@@ -142,7 +142,6 @@
         rxNode->AddDevice(rxDev);
 
         Ptr<SixLowPanNetDevice> rxSix = CreateObject<SixLowPanNetDevice>();
-        rxSix->SetAttribute("ForceEtherType", BooleanValue(true));
         rxSix->SetAttribute("Rfc6282", BooleanValue(false));
         rxNode->AddDevice(rxSix);
         rxSix->SetNetDevice(rxDev);
@@ -166,7 +165,6 @@
         txNode->AddDevice(txDev);
 
         Ptr<SixLowPanNetDevice> txSix = CreateObject<SixLowPanNetDevice>();
-        txSix->SetAttribute("ForceEtherType", BooleanValue(true));
         txSix->SetAttribute("Rfc6282", BooleanValue(false));
         txNode->AddDevice(txSix);
         txSix->SetNetDevice(txDev);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/sixlowpan/test/sixlowpan-iphc-test.cc ns-3.41/src/sixlowpan/test/sixlowpan-iphc-test.cc
--- ns-3.40/src/sixlowpan/test/sixlowpan-iphc-test.cc	2023-09-27 13:30:37.866839600 -0700
+++ ns-3.41/src/sixlowpan/test/sixlowpan-iphc-test.cc	2024-02-09 14:44:08.461794100 -0800
@@ -142,7 +142,6 @@
         rxNode->AddDevice(rxDev);
 
         Ptr<SixLowPanNetDevice> rxSix = CreateObject<SixLowPanNetDevice>();
-        rxSix->SetAttribute("ForceEtherType", BooleanValue(true));
         rxNode->AddDevice(rxSix);
         rxSix->SetNetDevice(rxDev);
 
@@ -165,7 +164,6 @@
         txNode->AddDevice(txDev);
 
         Ptr<SixLowPanNetDevice> txSix = CreateObject<SixLowPanNetDevice>();
-        txSix->SetAttribute("ForceEtherType", BooleanValue(true));
         txNode->AddDevice(txSix);
         txSix->SetNetDevice(txDev);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/examples/three-gpp-channel-example.cc ns-3.41/src/spectrum/examples/three-gpp-channel-example.cc
--- ns-3.40/src/spectrum/examples/three-gpp-channel-example.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/examples/three-gpp-channel-example.cc	2024-02-09 14:44:08.493794200 -0800
@@ -90,7 +90,7 @@
     double vAngleRadian = completeAngle.GetInclination(); // the elevation angle
 
     // retrieve the number of antenna elements and resize the vector
-    uint64_t totNoArrayElements = thisAntenna->GetNumberOfElements();
+    uint64_t totNoArrayElements = thisAntenna->GetNumElems();
     PhasedArrayModel::ComplexVector antennaWeights(totNoArrayElements);
 
     // the total power is divided equally among the antenna elements
@@ -131,14 +131,14 @@
     {
         activeRbs0[i] = i;
     }
-    Ptr<SpectrumValue> txPsd =
+    auto txPsd =
         LteSpectrumValueHelper::CreateTxPowerSpectralDensity(2100, 100, params.txPow, activeRbs0);
-    Ptr<SpectrumSignalParameters> txParams = Create<SpectrumSignalParameters>();
+    auto txParams = Create<SpectrumSignalParameters>();
     txParams->psd = txPsd->Copy();
     NS_LOG_DEBUG("Average tx power " << 10 * log10(Sum(*txPsd) * 180e3) << " dB");
 
     // create the noise PSD
-    Ptr<SpectrumValue> noisePsd =
+    auto noisePsd =
         LteSpectrumValueHelper::CreateNoisePowerSpectralDensity(2100, 100, params.noiseFigure);
     NS_LOG_DEBUG("Average noise power " << 10 * log10(Sum(*noisePsd) * 180e3) << " dB");
 
@@ -152,11 +152,12 @@
     NS_ASSERT_MSG(params.rxAntenna, "params.rxAntenna is nullptr!");
 
     // apply the fast fading and the beamforming gain
-    Ptr<SpectrumValue> rxPsd = m_spectrumLossModel->CalcRxPowerSpectralDensity(txParams,
-                                                                               params.txMob,
-                                                                               params.rxMob,
-                                                                               params.txAntenna,
-                                                                               params.rxAntenna);
+    auto rxParams = m_spectrumLossModel->CalcRxPowerSpectralDensity(txParams,
+                                                                    params.txMob,
+                                                                    params.rxMob,
+                                                                    params.txAntenna,
+                                                                    params.rxAntenna);
+    auto rxPsd = rxParams->psd;
     NS_LOG_DEBUG("Average rx power " << 10 * log10(Sum(*rxPsd) * 180e3) << " dB");
 
     // compute the SNR
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc ns-3.41/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc
--- ns-3.40/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc	2024-02-09 14:44:08.493794200 -0800
@@ -186,12 +186,12 @@
     bArray->SetBeamformingVector(bArray->GetBeamformingVector(angleAtoB));
 
     // Compute the received power due to multipath fading
-    auto rxPsd = threeGppSpectrumLossModel->DoCalcRxPowerSpectralDensity(signalParams,
-                                                                         aMob,
-                                                                         bMob,
-                                                                         aArray,
-                                                                         bArray);
-    double rxPower = ComputePowerSpectralDensityOverallPower(rxPsd);
+    auto rxParams = threeGppSpectrumLossModel->DoCalcRxPowerSpectralDensity(signalParams,
+                                                                            aMob,
+                                                                            bMob,
+                                                                            aArray,
+                                                                            bArray);
+    double rxPower = ComputePowerSpectralDensityOverallPower(rxParams->psd);
 
     return rxPower / txPower;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.cc ns-3.41/src/spectrum/model/constant-spectrum-propagation-loss.cc
--- ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/constant-spectrum-propagation-loss.cc	2024-02-09 14:44:08.493794200 -0800
@@ -99,4 +99,10 @@
     return rxPsd;
 }
 
+int64_t
+ConstantSpectrumPropagationLossModel::DoAssignStreams(int64_t stream)
+{
+    return 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.h ns-3.41/src/spectrum/model/constant-spectrum-propagation-loss.h
--- ns-3.40/src/spectrum/model/constant-spectrum-propagation-loss.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/constant-spectrum-propagation-loss.h	2024-02-09 14:44:08.493794200 -0800
@@ -57,8 +57,10 @@
     double GetLossDb() const;
 
   protected:
+    int64_t DoAssignStreams(int64_t stream) override;
     double m_lossDb;     //!< Propagation loss [dB]
     double m_lossLinear; //!< Propagation loss (linear)
+
   private:
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.cc ns-3.41/src/spectrum/model/friis-spectrum-propagation-loss.cc
--- ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/friis-spectrum-propagation-loss.cc	2024-02-09 14:44:08.493794200 -0800
@@ -94,4 +94,10 @@
     return loss;
 }
 
+int64_t
+FriisSpectrumPropagationLossModel::DoAssignStreams(int64_t stream)
+{
+    return 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.h ns-3.41/src/spectrum/model/friis-spectrum-propagation-loss.h
--- ns-3.40/src/spectrum/model/friis-spectrum-propagation-loss.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/friis-spectrum-propagation-loss.h	2024-02-09 14:44:08.493794200 -0800
@@ -65,6 +65,9 @@
      * @return if Prx < Ptx then return Prx; else return Ptx
      */
     double CalculateLoss(double f, double d) const;
+
+  protected:
+    int64_t DoAssignStreams(int64_t stream) override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.41/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.40/src/spectrum/model/multi-model-spectrum-channel.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/multi-model-spectrum-channel.cc	2024-02-09 14:44:08.497794400 -0800
@@ -417,7 +417,7 @@
                       "PhasedArrayModel instances should be installed at both TX and RX "
                       "SpectrumPhy in order to use PhasedArraySpectrumPropagationLoss.");
 
-        params->psd = m_phasedArraySpectrumPropagationLoss->CalcRxPowerSpectralDensity(
+        params = m_phasedArraySpectrumPropagationLoss->CalcRxPowerSpectralDensity(
             params,
             params->txPhy->GetMobility(),
             receiver->GetMobility(),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc ns-3.41/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc
--- ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2024-02-09 14:44:08.497794400 -0800
@@ -60,7 +60,13 @@
     m_next = next;
 }
 
-Ptr<SpectrumValue>
+Ptr<PhasedArraySpectrumPropagationLossModel>
+PhasedArraySpectrumPropagationLossModel::GetNext() const
+{
+    return m_next;
+}
+
+Ptr<SpectrumSignalParameters>
 PhasedArraySpectrumPropagationLossModel::CalcRxPowerSpectralDensity(
     Ptr<const SpectrumSignalParameters> params,
     Ptr<const MobilityModel> a,
@@ -71,14 +77,28 @@
     // Here we assume that all the models in the chain of models are of type
     // PhasedArraySpectrumPropagationLossModel that provides the implementation of
     // this function, i.e. has phased array model of TX and RX as parameters
-    Ptr<SpectrumValue> rxPsd =
+    auto rxParams =
         DoCalcRxPowerSpectralDensity(params, a, b, aPhasedArrayModel, bPhasedArrayModel);
+
     if (m_next)
     {
-        rxPsd =
+        rxParams =
             m_next->CalcRxPowerSpectralDensity(params, a, b, aPhasedArrayModel, bPhasedArrayModel);
     }
-    return rxPsd;
+    return rxParams;
+}
+
+int64_t
+PhasedArraySpectrumPropagationLossModel::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    auto currentStream = stream;
+    currentStream += DoAssignStreams(stream);
+    if (m_next)
+    {
+        currentStream += m_next->AssignStreams(currentStream);
+    }
+    return (currentStream - stream);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h ns-3.41/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h
--- ns-3.40/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h	2024-02-09 14:44:08.497794400 -0800
@@ -62,6 +62,13 @@
     void SetNext(Ptr<PhasedArraySpectrumPropagationLossModel> next);
 
     /**
+     * Return the pointer to the next PhasedArraySpectrumPropagationLossModel, if any.
+     *
+     * @return Pointer to the next model, if any
+     */
+    Ptr<PhasedArraySpectrumPropagationLossModel> GetNext() const;
+
+    /**
      * This method is to be called to calculate
      *
      * @param txPsd the spectrum signal parameters.
@@ -70,18 +77,42 @@
      * @param aPhasedArrayModel the instance of the phased antenna array of the sender
      * @param bPhasedArrayModel the instance of the phased antenna array of the receiver
      *
-     * @return set of values Vs frequency representing the received
-     * power in the same units used for the txPower parameter.
+     * @return SpectrumSignalParameters in which is updated the PSD to contain
+     * a set of values Vs frequency representing the received
+     * power in the same units used for the txPower parameter,
+     * and additional chanSpectrumMatrix is computed to support MIMO systems.
      */
-    Ptr<SpectrumValue> CalcRxPowerSpectralDensity(
+    Ptr<SpectrumSignalParameters> CalcRxPowerSpectralDensity(
         Ptr<const SpectrumSignalParameters> txPsd,
         Ptr<const MobilityModel> a,
         Ptr<const MobilityModel> b,
         Ptr<const PhasedArrayModel> aPhasedArrayModel,
         Ptr<const PhasedArrayModel> bPhasedArrayModel) const;
 
+    /**
+     * If this loss model uses objects of type RandomVariableStream,
+     * set the stream numbers to the integers starting with the offset
+     * 'stream'. Return the number of streams (possibly zero) that
+     * have been assigned.  If there are PhasedArraySpectrumPropagationLossModels
+     * chained together, this method will also assign streams to the
+     * downstream models.
+     *
+     * \param stream the stream index offset start
+     * \return the number of stream indices assigned by this model
+     */
+    int64_t AssignStreams(int64_t stream);
+
   protected:
     void DoDispose() override;
+    /**
+     * Assign a fixed random variable stream number to the random variables used by this model.
+     *
+     * Subclasses must implement this; those not using random variables can return zero.
+     *
+     * \param stream first stream index to use
+     * \return the number of stream indices assigned by this model
+     */
+    virtual int64_t DoAssignStreams(int64_t stream) = 0;
 
   private:
     /**
@@ -92,10 +123,12 @@
      * @param aPhasedArrayModel the instance of the phased antenna array of the sender
      * @param bPhasedArrayModel the instance of the phased antenna array of the receiver
      *
-     * @return set of values Vs frequency representing the received
-     * power in the same units used for the txPower parameter.
+     * @return SpectrumSignalParameters in which is updated the PSD to contain
+     * a set of values Vs frequency representing the received
+     * power in the same units used for the txPower parameter,
+     * and additional chanSpectrumMatrix is set.
      */
-    virtual Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity(
+    virtual Ptr<SpectrumSignalParameters> DoCalcRxPowerSpectralDensity(
         Ptr<const SpectrumSignalParameters> params,
         Ptr<const MobilityModel> a,
         Ptr<const MobilityModel> b,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-channel.cc ns-3.41/src/spectrum/model/spectrum-channel.cc
--- ns-3.40/src/spectrum/model/spectrum-channel.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-channel.cc	2024-02-09 14:44:08.497794400 -0800
@@ -19,6 +19,7 @@
 
 #include "spectrum-channel.h"
 
+#include <ns3/abort.h>
 #include <ns3/double.h>
 #include <ns3/log.h>
 #include <ns3/pointer.h>
@@ -158,7 +159,7 @@
     m_filter = filter;
 }
 
-Ptr<const SpectrumTransmitFilter>
+Ptr<SpectrumTransmitFilter>
 SpectrumChannel::GetSpectrumTransmitFilter() const
 {
     return m_filter;
@@ -167,28 +168,100 @@
 void
 SpectrumChannel::SetPropagationDelayModel(Ptr<PropagationDelayModel> delay)
 {
-    NS_ASSERT(!m_propagationDelay);
+    NS_ABORT_MSG_IF(m_propagationDelay, "Error, called SetPropagationDelayModel() twice");
     m_propagationDelay = delay;
 }
 
 Ptr<SpectrumPropagationLossModel>
-SpectrumChannel::GetSpectrumPropagationLossModel()
+SpectrumChannel::GetSpectrumPropagationLossModel() const
 {
-    NS_LOG_FUNCTION(this);
     return m_spectrumPropagationLoss;
 }
 
 Ptr<PhasedArraySpectrumPropagationLossModel>
-SpectrumChannel::GetPhasedArraySpectrumPropagationLossModel()
+SpectrumChannel::GetPhasedArraySpectrumPropagationLossModel() const
 {
-    NS_LOG_FUNCTION(this);
     return m_phasedArraySpectrumPropagationLoss;
 }
 
 Ptr<PropagationLossModel>
-SpectrumChannel::GetPropagationLossModel()
+SpectrumChannel::GetPropagationLossModel() const
 {
     return m_propagationLoss;
 }
 
+Ptr<PropagationDelayModel>
+SpectrumChannel::GetPropagationDelayModel() const
+{
+    return m_propagationDelay;
+}
+
+int64_t
+SpectrumChannel::AssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    auto currentStream = stream;
+    auto lastCurrentStream = stream;
+    if (m_propagationLoss)
+    {
+        currentStream += m_propagationLoss->AssignStreams(currentStream);
+    }
+    if (currentStream - lastCurrentStream)
+    {
+        NS_LOG_DEBUG("PropagationLossModel objects used " << currentStream - lastCurrentStream
+                                                          << " streams");
+    }
+    lastCurrentStream = currentStream;
+    if (m_propagationDelay)
+    {
+        m_propagationDelay->AssignStreams(currentStream);
+        currentStream += 1;
+    }
+    if (currentStream - lastCurrentStream)
+    {
+        NS_LOG_DEBUG("PropagationDelayModel object used " << currentStream - lastCurrentStream
+                                                          << " streams");
+    }
+    lastCurrentStream = currentStream;
+    if (m_spectrumPropagationLoss)
+    {
+        currentStream += m_spectrumPropagationLoss->AssignStreams(currentStream);
+    }
+    if (currentStream - lastCurrentStream)
+    {
+        NS_LOG_DEBUG("SpectrumPropagationLossModel objects used "
+                     << currentStream - lastCurrentStream << " streams");
+    }
+    lastCurrentStream = currentStream;
+    if (m_phasedArraySpectrumPropagationLoss)
+    {
+        currentStream += m_phasedArraySpectrumPropagationLoss->AssignStreams(currentStream);
+    }
+    if (currentStream - lastCurrentStream)
+    {
+        NS_LOG_DEBUG("PhasedArraySpectrumPropagationLossModel objects used "
+                     << currentStream - lastCurrentStream << " streams");
+    }
+    lastCurrentStream = currentStream;
+    if (m_filter)
+    {
+        currentStream += m_filter->AssignStreams(currentStream);
+    }
+    if (currentStream - lastCurrentStream)
+    {
+        NS_LOG_DEBUG("SpectrumTransmitFilter objects used " << currentStream - lastCurrentStream
+                                                            << " streams");
+    }
+    currentStream += DoAssignStreams(currentStream);
+    NS_LOG_DEBUG("Assigned a total of " << currentStream - stream << " streams");
+    return (currentStream - stream);
+}
+
+int64_t
+SpectrumChannel::DoAssignStreams(int64_t stream)
+{
+    NS_LOG_FUNCTION(this << stream);
+    return 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-channel.h ns-3.41/src/spectrum/model/spectrum-channel.h
--- ns-3.40/src/spectrum/model/spectrum-channel.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-channel.h	2024-02-09 14:44:08.497794400 -0800
@@ -92,7 +92,10 @@
         Ptr<PhasedArraySpectrumPropagationLossModel> loss);
 
     /**
-     * Set the propagation delay model to be used
+     * Set the propagation delay model to be used.  This method will abort
+     * the simulation if there exists a previously set propagation delay model
+     * (i.e., unlike propagation loss models, multiple of which can be chained
+     * together, there is only one propagation delay model).
      * \param delay Ptr to the propagation delay model to be used.
      */
     void SetPropagationDelayModel(Ptr<PropagationDelayModel> delay);
@@ -101,20 +104,26 @@
      * Get the frequency-dependent propagation loss model.
      * \returns a pointer to the propagation loss model.
      */
-    Ptr<SpectrumPropagationLossModel> GetSpectrumPropagationLossModel();
+    Ptr<SpectrumPropagationLossModel> GetSpectrumPropagationLossModel() const;
 
     /**
      * Get the frequency-dependent propagation loss model that is
      * compatible with the phased antenna arrays at TX and RX
      * \returns a pointer to the propagation loss model.
      */
-    Ptr<PhasedArraySpectrumPropagationLossModel> GetPhasedArraySpectrumPropagationLossModel();
+    Ptr<PhasedArraySpectrumPropagationLossModel> GetPhasedArraySpectrumPropagationLossModel() const;
 
     /**
      * Get the propagation loss model.
      * \returns a pointer to the propagation loss model.
      */
-    Ptr<PropagationLossModel> GetPropagationLossModel();
+    Ptr<PropagationLossModel> GetPropagationLossModel() const;
+
+    /**
+     * Get the propagation delay model that has been set on the channel.
+     * \returns a pointer to the propagation delay model.
+     */
+    Ptr<PropagationDelayModel> GetPropagationDelayModel() const;
 
     /**
      * Add the transmit filter to be used to filter possible signal receptions
@@ -131,7 +140,7 @@
      * if more than one is present.
      * \returns a pointer to the transmit filter.
      */
-    Ptr<const SpectrumTransmitFilter> GetSpectrumTransmitFilter() const;
+    Ptr<SpectrumTransmitFilter> GetSpectrumTransmitFilter() const;
 
     /**
      * Used by attached PHY instances to transmit signals on the channel
@@ -141,6 +150,20 @@
     virtual void StartTx(Ptr<SpectrumSignalParameters> params) = 0;
 
     /**
+     * This method calls AssignStreams() on any/all of the PropagationLossModel,
+     * PropagationDelayModel, SpectrumPropagationLossModel,
+     * PhasedArraySpectrumPropagationLossModel, and SpectrumTransmitFilter
+     * objects that have been added to this channel.  If any of those
+     * objects are chained together (e.g., multiple PropagationDelayModel
+     * objects), the base class of that object is responsible for ensuring
+     * that all models in the chain have AssignStreams recursively called.
+     *
+     * \param stream the stream index offset start
+     * \return the number of stream indices assigned by this model
+     */
+    int64_t AssignStreams(int64_t stream);
+
+    /**
      * \brief Remove a SpectrumPhy from a channel
      *
      * This method is used to detach a SpectrumPhy instance from a
@@ -207,6 +230,15 @@
 
   protected:
     /**
+     * This provides a base class implementation that may be subclassed
+     * if needed by subclasses that might need additional stream assignments.
+     *
+     * \param stream first stream index to use
+     * \return the number of stream indices assigned by this model
+     */
+    virtual int64_t DoAssignStreams(int64_t stream);
+
+    /**
      * The `PathLoss` trace source. Exporting the pointers to the Tx and Rx
      * SpectrumPhy and a pathloss value, in dB.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-model.h ns-3.41/src/spectrum/model/spectrum-model.h
--- ns-3.40/src/spectrum/model/spectrum-model.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-model.h	2024-02-09 14:44:08.497794400 -0800
@@ -22,6 +22,7 @@
 
 #include <ns3/simple-ref-count.h>
 
+#include <cstddef>
 #include <vector>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-propagation-loss-model.cc ns-3.41/src/spectrum/model/spectrum-propagation-loss-model.cc
--- ns-3.40/src/spectrum/model/spectrum-propagation-loss-model.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-propagation-loss-model.cc	2024-02-09 14:44:08.497794400 -0800
@@ -59,6 +59,12 @@
     m_next = next;
 }
 
+Ptr<SpectrumPropagationLossModel>
+SpectrumPropagationLossModel::GetNext() const
+{
+    return m_next;
+}
+
 Ptr<SpectrumValue>
 SpectrumPropagationLossModel::CalcRxPowerSpectralDensity(Ptr<const SpectrumSignalParameters> params,
                                                          Ptr<const MobilityModel> a,
@@ -72,4 +78,16 @@
     return rxPsd;
 }
 
+int64_t
+SpectrumPropagationLossModel::AssignStreams(int64_t stream)
+{
+    auto currentStream = stream;
+    currentStream += DoAssignStreams(stream);
+    if (m_next)
+    {
+        currentStream += m_next->AssignStreams(currentStream);
+    }
+    return (currentStream - stream);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-propagation-loss-model.h ns-3.41/src/spectrum/model/spectrum-propagation-loss-model.h
--- ns-3.40/src/spectrum/model/spectrum-propagation-loss-model.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-propagation-loss-model.h	2024-02-09 14:44:08.497794400 -0800
@@ -60,6 +60,13 @@
     void SetNext(Ptr<SpectrumPropagationLossModel> next);
 
     /**
+     * Return the pointer to the next SpectrumPropagationLossModel, if any.
+     *
+     * @return Pointer to the next model, if any.
+     */
+    Ptr<SpectrumPropagationLossModel> GetNext() const;
+
+    /**
      * This method is to be called to calculate
      *
      * @param params the spectrum signal parameters.
@@ -73,8 +80,30 @@
                                                   Ptr<const MobilityModel> a,
                                                   Ptr<const MobilityModel> b) const;
 
+    /**
+     * If this loss model uses objects of type RandomVariableStream,
+     * set the stream numbers to the integers starting with the offset
+     * 'stream'. Return the number of streams (possibly zero) that
+     * have been assigned.  If there are SpectrumPropagationLossModels chained
+     * together, this method will also assign streams to the
+     * downstream models.
+     *
+     * \param stream the stream index offset start
+     * \return the number of stream indices assigned by this model
+     */
+    int64_t AssignStreams(int64_t stream);
+
   protected:
     void DoDispose() override;
+    /**
+     * Assign a fixed random variable stream number to the random variables used by this model.
+     *
+     * Subclasses must implement this; those not using random variables can return zero.
+     *
+     * \param stream first stream index to use
+     * \return the number of stream indices assigned by this model
+     */
+    virtual int64_t DoAssignStreams(int64_t stream) = 0;
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-signal-parameters.cc ns-3.41/src/spectrum/model/spectrum-signal-parameters.cc
--- ns-3.40/src/spectrum/model/spectrum-signal-parameters.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-signal-parameters.cc	2024-02-09 14:44:08.497794400 -0800
@@ -47,6 +47,10 @@
     duration = p.duration;
     txPhy = p.txPhy;
     txAntenna = p.txAntenna;
+    spectrumChannelMatrix = p.spectrumChannelMatrix; // we do not need a deep copy, it will not be
+                                                     // changed once is created
+    precodingMatrix =
+        p.precodingMatrix; // we do not need a deep copy, it will not be changed once is created
 }
 
 Ptr<SpectrumSignalParameters>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-signal-parameters.h ns-3.41/src/spectrum/model/spectrum-signal-parameters.h
--- ns-3.40/src/spectrum/model/spectrum-signal-parameters.h	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-signal-parameters.h	2024-02-09 14:44:08.497794400 -0800
@@ -20,9 +20,8 @@
 #ifndef SPECTRUM_SIGNAL_PARAMETERS_H
 #define SPECTRUM_SIGNAL_PARAMETERS_H
 
+#include <ns3/matrix-array.h>
 #include <ns3/nstime.h>
-#include <ns3/ptr.h>
-#include <ns3/simple-ref-count.h>
 
 namespace ns3
 {
@@ -111,6 +110,20 @@
      * The AntennaModel instance that was used to transmit this signal.
      */
     Ptr<AntennaModel> txAntenna;
+
+    /**
+     * The 3D channel matrix where the dimensions are: the number of RX ports,
+     * the number of TX Ports, the number of resource blocks (RBs).
+     * Needed in the MIMO system in which multiple TX and RX ports can exist,
+     * hence the PSD is multidimensional. Elements are the complex numbers.
+     */
+    Ptr<const ComplexMatrixArray> spectrumChannelMatrix;
+
+    /**
+     * The 3D precoding matrix where the dimensions are: the number of TX ports,
+     * the number of TX streams, the number of RBs.
+     */
+    Ptr<const ComplexMatrixArray> precodingMatrix;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/spectrum/model/spectrum-transmit-filter.cc ns-3.41/src/spectrum/model/spectrum-transmit-filter.cc
--- ns-3.40/src/spectrum/model/spectrum-transmit-filter.cc	2023-09-27 13:30:37.874839800 -0700
+++ ns-3.41/src/spectrum/model/spectrum-transmit-filter.cc	2024-02-09 14:44:08.497794400 -0800
@@ -87,4 +87,16 @@
     }
 }
 
+int64_t
+SpectrumTransmitFilter::AssignStreams(int64_t stream)
+{
+    auto currentStream = stream;
+    currentStream += DoAssignStreams(stream);
+    if (m_next)
+    {
+        currentStream += m_next->AssignStreams(currentStream);
+    }
+    return (currentStream - stream);
+}
+
 } // namespace ns3
